/** GanzzahlEuklid.java
 *
 *  Eine Applikation, die den Euklid'schen Algorithmus
 *  zur ggT-Berechnung im Bereich der ganzen Zahlen realisiert
 *
 *  Konvention: g.g.T.(0,0) = 0  
 *  (nur Zahlenwerte!)
 */

import java.io.*;

class GanzzahlEuklid {

   public static void main (String[] args) throws Exception {

	// Definitionen
	InputStreamReader ipr = new InputStreamReader(System.in);
   	BufferedReader keyboard = new BufferedReader(ipr);      

	int x,y, xIn, yIn;

	// Dialog
	System.out.print("Wert fuer x: ");
	xIn = Integer.parseInt(keyboard.readLine());
	System.out.print("Wert fuer y: ");
	yIn = Integer.parseInt(keyboard.readLine());

	// Berechnung vorbereiten
	x = xIn;
	y = yIn;

	// Sonderfall abfangen
	if (x == 0)	// wenn ein Wert 0, 
	   x = y;	// dann ist der g.g.T.
	if (y == 0)	// der Wert der jeweils
	   y = x;	// anderen Variablen

	// Vorbereitung bei negetiven Werten
	if (x < 0)	// Endlosschleife vermeiden:
	   x = -x;	// mit entgegengesetzten 
	if (y < 0)	// Werten rechnen
	   y = -y;	// --> positiver g.g.T.

	// Algorithmus von Euklid
	while (x != y) 	
	   if (x > y)
		x = x - y;
	   else
		y = y - x; 

	// Ausgabe
	System.out.println("ggT(" + xIn + "," + yIn + ") = " + x);
   }
} 

// GanzzahlEuklid
