import java.io.*;

/**
 * Simulates the calculation of permissions for umask in UNIX:
 * bitwise AND-operation of base value and negated umask
 */
class Permissions {

	public static void main(String[] args) throws Exception {

		InputStreamReader ipr = new InputStreamReader(System.in);
		BufferedReader keyboard = new BufferedReader(ipr);	

		int baseValue, umask, permissions;
		String type;

		// set base value
		baseValue = 0666; 	// Octal value

		System.out.print("Do you want to calculate the permissions for a directory? ('y/n')? ");
		type = keyboard.readLine();

		if (type.equals("y")) {		// Compare strings
			baseValue = 0777;	// Octal value
		}

		System.out.print("Enter the current umask value: ");
		umask = Integer.parseInt(keyboard.readLine(), 8);   // as octal value

		// Calculate permissions
		permissions = baseValue & (~umask);

		// Output
		System.out.println("Your permissions: " + Integer.toOctalString(permissions));
	}
}
